/* SACHICA: Scalable Algorithm for Charactaristic and Homologineous Interval CAluclation */
/* 2004 Takeaki Uno */
// #include"stdlib2.c"

#ifndef _sachica_c_
#define _sachica_c_

// comment out if single-core mode
//#define MULTI_CORE
#define WEIGHT_DOUBLE

#include"sachica.h"
#include"pos.c"
#include"problem.c"

/* error message */
void SACHICA_error (){
  ERROR_MES = "command explanation";
  print_err (" SACHICA: Scalable Algorithm for Characteristic/Homologinoeus Interval CAlculation, Ver2.00b\n\n\
usage: sachica _%%+pmrcCZflHEQvSiGJsNIMdOoh [options] input-filename length #err [output-filename]\n\
%%:show progress, _:no message, +:write solutions in append mode\n\
p:find matching pairs, m:compute mismatch tolerance\n\
g:output sets of positions having the same k-d blocks\n\
r:count #similar substrings for each positions in each substring of length [len]\n\
c:multi string comparison, C:read file as multi string, but compare as usual (compare substrings in one string\n\
Z:output maximal continuous-small-mismatch intervals\n\
f:(in Z mode)output the length by #substrings (of length [len]) in the intarval (length will be (length - [len] +1) \n\
l:compare substrings at interleaving positions\n\
H,E:use Hamming distance/edit distance for distance measure in the pair extension\n\
Q:output a pair if a chunk of them matches\n\
v:count numbers for each position of substrings (for rZ mode)\n\
S:count #similar strings/mismatch tolerance for each string\n\
i:ignore newline characters '\\n' in input file\n\
G:genome sequence mode (fasta file), J:(In genome mode), regard '>'\n\
(comment) as a separator, J:(sachica16) read text in Japanese EUC mode\n\
J:(sachica32)regard each byte as 1 digit of at most 200 (32 -> 0,..., 231 -> 199).\n\
0:read number-sequence file\n\
s:output substring for each position/pair found\n\
N:output numbers instead of letters (valid only in 32-bit mode)\n\
I:output intervals of continuous small/large mismatch tolerance\n\
M:(with m,r command) output positions with large #similar substrings/mismatch tolerance\n\
  (with p command) output pairs only when for at least one position the other is nearest\n\
d:output string IDs, D:do not output positions, n:normalize positions of all strings\n\
O,o:output overlapping strings (oneside, if 'o')\n\
h:(for -v option):output similar strings if the condition is satisfied for at least one string\n\
(if -x [num] is given, find only inclusion with gap [num]-1 letters from both side)\n\
[options]: can be abbribiated\n\
-2 [filename]:read additional file, attached to the input file\n\
-P [filename]:read position list file (-PP:with format 'strID,postion' pair)\n\
-s [char]:ignore the substrings including [char] (specifiy by numbers in 32bit mode)\n\
-S [char]:ignore the substrings including more than #err of [char]s (specifiy by numbers in 32bit mode)\n\
-R [num] [shift-len]:ignore each substring s.t. the Hamming distance to the substring obtained by shifted at most [shift-len] letters is at most [num]\n\
-d [num]:duplicate strings from [num]th to the end\n\
-r [num]:reverse strings from [num]th string to the last string\n\
-3 [num]:matrix mode for each string up to [num]th (all strings if 0 is given)\n\
-y [num]:set pattern y-length and execute as matrix mode (segment mode if -1)\n\
-D [num]: compute the mismatch with considering each letter as [num]-digit\n\
-C [filename]: read mismatch tolerance/#similar pair file\n\
-p [num]:extend the output interval [num] letters to both directions\n\
-o [num]:output what related to strings from 1st to [num]th\n\
-n [num]:normalize positions by [num]th string\n\
-b,-B [num]:add [num] to each position/ID (-B [num] is for the second position/ID)\n\
-u,-l [num]:upper/lower bounds for the length of intervals to be output [upper/lower bounds of groups to be output, for g command]\n\
-w [char]:specify wildcard which matches to every letter (not completely work)\n\
-h [filename]:print positions of head/tail of each string to [filename]\n\
-I [num]:specify interleave length, used to sampling the short strings\n\
-i [num]:specify the first number of the interleave ([num] consecutive positions will be taken)\n\
-q,-Q [num]: specify number of blocks and chunks\n\
-k [num]:output at most [num] pairs for each substring ((r/m command) give threshold to output position)\n\
-m [num]:execute the program with mismatch number from [num]\n\
-+ [num]:how much do we increment mismatch number in each iteration\n\
-Y [num]:remove the positions of the strings up to [num] from the candidates when the current distance is larger than the mismatch tolerrance\n\
-c [num]:compare strings 1 to [num]-1th, and the other strings\n\
-e [num]:set max absolute error number for similarity extension\n\
-E [real-num]:set max error ratio for similar pair extension\n\
    (error ratio will be #err/length for overlap, if O or o command is given)\n\
-v [ratio]:output the similar strings only if the length of similar strings is no less than the ratio of both strings\n\
-G,-g [num]: constraint for gap of pair, -G is maximum, -g minimum [num]\n\
-T [num]: considering each letter as [num]-digit, and compute the cost by the difference of the letter. if the distance is larger than [num], then the distance will be infinitly big number\n\
-M [num]: for multi-core processors, use [num] processors (threads: need to be compiled with multi_core option\n\
-R [num] [len]: ignore repeating strings, with checking [len] shifts (a string is ignored if there is an i s.t., the string and its substring starting from its ith position has Hamming distance at most [num])\n\
-t [num]:give up pairwise comparison if group size is more than [num]\n\
-# [num]:stop after outputting [num] solutions\n\
-, [char]:give the separator of the numbers in the output\n\
\n sachica P input-filename [num] [len]\n\
print substring of the input from [num] with length of [len] (s: print [num]th substring)\n\
   The input string is separeted by '\\n\\n' to multiple strings\n\
-C, I options are valid in this mode\n\
# for -d, -r, -c, -n, -3 and -o options, [num] will be set to the first string in the second file, or the half of strings (except for -d), if [num] is -1. [num] will be set to the ID of top string generated by -d option if [num] is -2.\n\
# -r -3: reverse strings in even lines, for double read mode\n\
# the 1st letter of input-filename cannot be '-'\n\
# if the output file name is -, the solutions will be output to standard output.\n");
  EXIT;
}
// -x [num]:extend each substring for each direction with length [num] while they are similar [default measure is CIH)

/* read commands and options from command line */
void SACHICA_read_param (int argc, char *argv[], SACHICA *SA){
  int c=1, k_flag = 0;
  PROBLEM *PP = &SA->PP;
  SEQ *SS = &PP->SS;
  POS *PS = &PP->PS;
  
  SA->trancate = 0;
  PS->sc_mark = POS_SC_END-1; PS->sc_mark2 = POS_SC_END-2;
  if ( argc < c+4 ) SACHICA_error ();
  
  if ( strchr (argv[c], 'p') ){ SS->flag |= SEQ_OUTPUT_PAIR; PP->problem |= SACHICA_PAIR; }
  else if ( strchr( argv[c], 'g') ){  SS->flag |= SEQ_OUTPUT_PAIR; PP->problem |= SACHICA_GROUP+SACHICA_PAIR; }
  else if ( strchr( argv[c], 'm') ){ PP->problem |= SACHICA_MISMATCH; PS->flag |= POS_SC_MIN+POS_SC_USE; }
  else if ( strchr (argv[c], 'r') ){ PP->problem |= SACHICA_REPEAT; PS->flag |= POS_SC_COUNT+POS_SC_USE;}
//  else if ( strchr (argv[c], 'r') ){ PP->problem |= SACHICA_REPEAT;}
  else if ( strchr (argv[c], 'P') ) PP->problem |= SACHICA_PRINT;
  if ( PP->problem == 0 ) error ("one of P, p, r, or m has to be given", EXIT);

  if ( strchr (argv[c], '2') ){   // not implemented now!!!
    if ( PP->problem & SACHICA_SOLEXA ) PP->problem |= SACHICA_DOUBLE_READ;
  }

//  if ( strchr (argv[c], 'S') ) PP->problem |= SACHICA_SELF_COMPARISON;
  if ( strchr (argv[c], 'l') ) SS->interleave_len_org = 0;

  if ( !strchr (argv[c], '_') ) SS->flag |= SHOW_MESSAGE;
  if ( strchr (argv[c], '%') ) PP->II.flag |= SHOW_PROGRESS;
  if ( strchr (argv[c], '+') ) PP->II.flag |= ITEMSET_APPEND;

  if ( strchr (argv[c], 'c') ) SS->flag |= SEQ_MULTI_STRING;
  if ( strchr (argv[c], 'C') ){ SS->flag |= SEQ_MULTI_STRING; PP->problem |= SACHICA_NO_MULTI; }
  if ( strchr (argv[c], 'Z') ){ SS->flag |= SEQ_MAXIMAL; PS->flag |= POS_SC_COUNT_INTERVAL; }
  if ( strchr (argv[c], 'v') ) PS->flag |= POS_SC_COUNT_INTERVAL + POS_SC_COUNT_INTERVAL_EXTEND;
  if ( strchr (argv[c], 'H') ) SS->flag |= SEQ_HAMMING_DISTANCE;
  if ( strchr (argv[c], 'E') ) SS->flag |= SEQ_EDIT_DISTANCE;
  if ( strchr (argv[c], 'Q') ) PS->flag |= POS_ONE_CHUNK_MATCH;
  if ( strchr (argv[c], 'S') ){
    PS->flag |= POS_STR_SC;   // +SEQ_OUTPUT_ID;
//    SS->flag |= SEQ_NO_OUTPUT_POSITION;
    if ( PP->problem & SACHICA_MISMATCH ){
      PS->flag |= POS_STR_SC_MIN;
      PS->flag -= (PS->flag & (POS_SC_USE + POS_SC_MIN));
    }
  }

  if ( strchr (argv[c], 'i') ) SS->flag |= SEQ_IGNORE_NEWLINE;
  if ( strchr (argv[c], 'G') ) SS->flag |= SEQ_GENOME;
  if ( strchr (argv[c], 'J') ) SS->flag |= SEQ_EUC;
  if ( strchr (argv[c], '0') ) SS->flag |= SEQ_NUM;

  if ( strchr (argv[c], 's') ) SS->flag |= SEQ_OUTPUT_STRING;
  if ( strchr (argv[c], 'N') ) SS->flag |= SEQ_PUTC_NUM;
  if ( strchr (argv[c], 'I') ) SS->flag |= SEQ_OUTPUT_INTERVAL;
  if ( strchr (argv[c], 'M') ) PS->flag |= POS_SC_OUTPUT_ONLY_MAX;
  if ( strchr (argv[c], 'n') ) SS->flag |= SEQ_NORMALIZE;
  if ( strchr (argv[c], 'd') ) SS->flag |= SEQ_OUTPUT_ID;
  if ( strchr (argv[c], 'D') ) SS->flag |= SEQ_NO_OUTPUT_POSITION;
  if ( strchr (argv[c], 'o') ) PP->problem |= SACHICA_OVERLAP1;
  if ( strchr (argv[c], 'O') ) PP->problem |= SACHICA_OVERLAP;
  if ( strchr (argv[c], 'f') ) PP->problem |= SACHICA_LENGTH_HEAD;
  if ( strchr (argv[c], 'h') ) PP->problem |= SACHICA_ONE_SIMILAR;

//  if ( strchr (argv[c], 'y') ) PS->flag |= POS_SC_MIN;

//  if ( strchr (argv[c], 'v') ) PP->problem |= SACHICA_EXT_VALID;
//  if ( strchr (argv[c], 'x') ) PP->problem |= SACHICA_MINIMAL;
  c++;

  while (argv[c][0] == '-'){
    switch (argv[c][1]){
      case '2': SS->fname2 = argv[c+1];
      break; case 'P': PS->fname = argv[c+1];
        if ( argv[c][2] == 'P' ){ PS->flag |= POS_LOAD_STRPOS_PAIR; }
      break; case 'y':
        if ( (SS->ylen=atoi(argv[c+1])) < -1 )
            error_num("pattern y-length (-y) has to be positive or -1", SS->ylen, EXIT);
        if ( SS->ylen == -1 ){
          SS->ylen = 1; SS->flag |= SEQ_SEGMENT;
          if ( (SS->flag&SEQ_OUTPUT_ID) && !strchr (argv[1], 'd') ) SS->flag -= SEQ_OUTPUT_ID;
        }
      break; case 'k': 
        if ( k_flag ==0 && ((PS->flag&POS_STR_SC) || (PP->problem&(SACHICA_OVERLAP1 +SACHICA_OVERLAP))) ){
          k_flag = 1;  // the second -k will be regarded for sc.
          if ( atoi(argv[c+1]) < 0 || atoi(argv[c+1]) >= INTHUGE )
            error_num("the number following '-k' has to be in [0,max]",atoi(argv[c+1]), EXIT);
          if ( PP->problem & (SACHICA_MISMATCH+SACHICA_REPEAT) ) PS->sc_th = atoi(argv[c+1]); // !! range check 
          else { PS->flag |= POS_STR_SC_COUNT; PS->str_sc_max = atoi(argv[c+1]); } // !! range check 
        } else {
          PS->flag |= POS_SC_USE;
          if ( atoi(argv[c+1]) < 0 || atoi(argv[c+1]) >= POS_SC_END )
            error_num("the number following '-k' has to be in [0,max]",atoi(argv[c+1]), EXIT);
          if ( PP->problem & (SACHICA_MISMATCH+SACHICA_REPEAT) ) PS->sc_th = atoi(argv[c+1]); // !! range check 
          else { PS->flag |= POS_SC_COUNT; PS->sc_max = atoi(argv[c+1]); } // !! range check 
//          if ( PP->problem & SACHICA_REPEAT ) PS->flag |= POS_SC_COUNT;
        }
      break; case 'Y': if ( (SS->reduced_by = atoi(argv[c+1])) < -2 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
      break; case 'm': SS->perr_min = atoi(argv[c+1]);
      break; case '+': if ( (SS->perr_inc = atoi(argv[c+1])) <= 0 )
          error_num("increament value has to be positive",atof(argv[c+1]), EXIT);
      break; case 'c': if ( (SS->separated_by = atoi(argv[c+1])) < -2 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
      break; case 'n': if ( (SS->normalized_by = atoi(argv[c+1])) < -2 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
      break; case 'o': if ( (SS->output_by = atoi(argv[c+1])) < -3 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
      break; case '3': if ( (SS->matrix_by = atoi(argv[c+1])) < -3 )
          error_num("string ID has to be positive, 0, -1, -2 or -3",atof(argv[c+1]), EXIT);
        if ( SS->matrix_by == 0 ) SS->matrix_by = INTHUGE;
        if ( SS->ylen == 0 ){ SS->ylen = 1; SS->flag |= SEQ_SEGMENT; }
      break; case 'd': if ( (SS->duplicated_by = atoi(argv[c+1])) < -2 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
      break; case 'b': SS->base1 = atoi(argv[c+1]);
      break; case 'B': SS->base2 = atoi(argv[c+1]);
      break; case 'v': if ( (SA->PP.th = atof(argv[c+1])) < 0 || SA->PP.th>1  )
          error_num("similarity-overlap ratio has to be between 0 and 1",SA->PP.th, EXIT);
      break; case 'p': SS->p_ext = atoi(argv[c+1]);
#ifdef SEQ_CHAR_LONG
      break; case 's': PS->skip_chr = atoi(argv[c+1]); PS->skip_chr_ub = 1;
      break; case 'S': PS->skip_chr = atoi(argv[c+1]); PS->skip_chr_ub = 2;
#else
      break; case 's': PS->skip_chr = argv[c+1][0]; PS->skip_chr_ub = 1;
      break; case 'S': PS->skip_chr = argv[c+1][0]; PS->skip_chr_ub = 2;
#endif
      break; case 'R': if ( (PS->skip_repeat_th = atoi(argv[c+1])) < 0 )
          error_num("repeat threashold (-R) has to be non-negative",atof(argv[c+1]), EXIT);
          if ( (PS->skip_repeat_check = atoi(argv[++c+1])) < 0 )
          error_num("repeat check length (-R) has to be non-negative",atof(argv[c+1]), EXIT);
//      break; case 'x': SS->extend = atoi(argv[c+1]); SS->flag |= POS_SC_COUNT_INTERVAL;
      break; case 'e': SS->err_max = atoi(argv[c+1]);
      break; case 'E': SS->err_ratio = atof(argv[c+1]);
      break; case 'G': if ( (PP->gap_ub = atoi(argv[c+1])) < 0 )
          error_num("gap upper bound has to be positive",atof(argv[c+1]), EXIT);
      break; case 'g': if ( (PP->gap_lb = atoi(argv[c+1])) < 0 )
          error_num("gap lower bound has to be positive",atof(argv[c+1]), EXIT);
      break; case 'l': if ( (SS->plen_lb = atoi(argv[c+1])) < 0 )
          error_num("lower bound for interval length has to be positive",atof(argv[c+1]), EXIT);
      break; case 'u': if ( (SS->plen_ub = atoi(argv[c+1])) < 0 )
          error_num("upper bound for interval length has to be positive",atof(argv[c+1]), EXIT);
      break; case 'r': if ( atoi(argv[c+1]) < -3 || atoi(argv[c+1]) == 0 )
          error_num("string ID has to be positive, -1, -2 or -3",atof(argv[c+1]), EXIT);
        if ( atoi(argv[c+1]) == -3 ) PP->problem |= SACHICA_DOUBLE_READ;
          else SS->reversed_by = atoi(argv[c+1]);
      break; case 'h': PP->header_fname = argv[c+1];
      break; case 'C': PP->sc_fname = argv[c+1];
      break; case 'I': if ( (SS->interleave_len_org = atoi(argv[c+1])) <= 0 )
          error_num("interleave length has to be positive",atof(argv[c+1]), EXIT);
      break; case 'i': if ( (SS->pos_skip_a = atoi(argv[c+1])) <= 0 )
          error_num("the first interleaving length has to be positive",atof(argv[c+1]), EXIT);
      break; case 'M': if ((PP->II.multi_core=atoi(argv[c+1])) <= 0 || atoi(argv[c+1])>CORE_MAX)
          error_num("number of cores has to be in 1 to",atof(argv[c+1]), EXIT);
      break; case 'q': PS->pblock_num_org = atoi(argv[c+1]);
      break; case 'Q': if ( (PS->chunk_org = atoi(argv[c+1])) <= 0 )
          error_num("#chunks has to be positive",atof(argv[c+1]), EXIT);
      break; case 'D': if ( (SS->micro_chr_num = atoi(argv[c+1])) <= 0 )
          error_num("micro-alphabet size has to be positive",atof(argv[c+1]), EXIT);
      break; case 'T': SS->micro_chr_dist = atoi(argv[c+1]);
      break; case 't': SA->trancate = atoi(argv[c+1]);
      break; case 'w': SS->wildcard = argv[c+1][0];
      break; case '#': PP->II.max_solutions = atoi(argv[c+1]);
      break; case ',': PP->II.separator = argv[c+1][0];
      break; default: goto NEXT;
    }
    c += 2;
    if ( argc < c+3 ) SACHICA_error ();
  }

  NEXT:;
  PP->SS.fname = argv[c];
  if ( (SS->plen_org = atoi(argv[c+1])) <=0 )
      error_num("pattern string length has to be positive",atof(argv[c+1]), EXIT);
  if ( PS->chunk_org>0 && SS->plen_org / PS->chunk_org < PS->pblock_num_org ) 
      error_num("block number has to be no larger than pattern length",atof(argv[c+1]), EXIT);
  if ( (SS->perr_org = atoi(argv[c+2])) <0 )
      error_num("#mismatch has to be non-negative",atof(argv[c+2]), EXIT);
  if ( SS->perr_org > SS->plen_org )
      error_num("#mismatch has to be no greater than pattern length",atof(argv[c+2]), EXIT);
  if ( PS->chunk_org >0 && PS->pblock_num_org > 0 && SS->perr_org / PS->chunk_org >= PS->pblock_num_org ) 
      error_num("block number has to be larger than #mismatch",atof(argv[c+2]), EXIT);
  if ( argc>=c+4 ) PP->output_fname = argv[c+3];
}

void SACHICA_set_param (SACHICA *SA){
  SEQ *SS = &SA->PP.SS;
  POS *PS = &SA->PP.PS;
  if ( PS->skip_chr_ub == 2 ) PS->skip_chr_ub = SS->perr_org;
  if ( SS->interleave_len_org == 0 ) SS->interleave_len_org = SS->plen_org;

   // additional parameter settings
  if ( SA->PP.problem & SACHICA_MISMATCH ) PS->sc_max = SS->perr_org; 
  if ( SS->err_max == -1 ) SS->err_max = SS->perr_org;
  if ( SS->perr_min == -INTHUGE ) SS->perr_min = SS->perr_org;
//  if ( (PP->problem&(SACHICA_OVERLAP+SACHICA_OVERLAP1)) && SS->err_ratio > 0 ) SS->err_max = 1;
    // correction for conflicting parameters
  if ( !(SS->flag & SEQ_MULTI_STRING) ) SS->separated_by = 0;
  if ( SS->flag & SEQ_NORMALIZE ) SS->normalized_by = 0;
  if ( SS->ylen > 0 ){ SS->xlen = SS->plen_org; SS->plen_org *= SS->ylen; } 
  if ( SS->flag & SEQ_MAXIMAL ) SS->err_max = SS->perr_org;

      // set initial value of sc and str_sc
  if ( SA->PP.problem&SACHICA_MISMATCH && !(PS->flag&POS_SC_COUNT) ){
    PS->init_sc = POS_SC_END-1; PS->sc_mark = 0; PS->sc_mark2 = 1;
  }
  if ( (SA->PP.problem&SACHICA_MISMATCH) && !(PS->flag&POS_STR_SC_COUNT) ) PS->init_str_sc = INTHUGE-1;}

/* output masked strings */
#define SACHICA_MASK_OUTPUT_LENGTH 50
#define SACHICA_MASK_DEFAULT_TRIM 30
void SACHICA_output_masked_string (SACHICA *SA){
  SEQ *SS = &SA->PP.SS;
  SEQ_ID i;
  FLOOP (i, 1, SS->str_num-2){  // output only fragments (num-2, num-1th are mask string and its reverse)
    if ( SA->headmax[i]+SACHICA_MASK_OUTPUT_LENGTH + SS->p_ext*2 < SA->tailmax[i] ){ 
      SEQ_fprint_string (SA->PP.II.fp, SS, &SS->s[SA->headmax[i]], SA->tailmax[i]-SA->headmax[i], 0);
      fprintf (SA->PP.II.fp, "\n\n");
printf (SEQ_LONGF " " SEQ_LONGF " (" SEQ_LONGF ")  ", SA->headmax[i]-SS->head[i], SA->tailmax[i]-SS->head[i], SS->tail[i]-SS->head[i]);
    } else printf ("0 0  ");
    if (SA->headmax[i] > SS->head[i]+SS->p_ext ) printf ("#"); else printf ("=");
    if (SA->tailmax[i] < SS->tail[i]-SS->p_ext ) printf ("#"); else printf ("=");
    printf ("\n");
  }
}

/* extract maximum length substring continuously includes few ignoring char's */
void SEQ_extract_valid_string (SEQ *S, char c, int ub){
  int k;
  SEQ_ID i;
  SEQ_LONG j, jj, m=0, ml=0, mr=0;
  FLOOP (i, 1, S->str_num){
    for (k=0,j=jj=S->head[i] ; j<S->head[i]+S->plen_org ; j++)
        if ( S->unperm[S->s[j]] == c ) k++;
    while (1){
      if ( k > ub ){
        if ( j-jj > m ){ ml=jj, mr=j; m=jj-j; }
        jj=j+1;
      }
      if ( j>=S->tail[i]-S->plen_org ) break;
      if ( S->unperm[S->s[j-S->plen_org]] == c ) k--;
      if ( S->unperm[S->s[j]] == c ) k++;
      j++;
    }
    for (jj=0,j=ml ; j<mr ; j++,jj++) S->s[jj] = S->s[j];
    S->tail[i] = mr - ml;
  }
}


/* shift positions according to current operating super block 
   change positions and {ppartitions, dep_max, dep} */
void POS_shift_pos (POS *P, int k ){
  SEQ_LONG t;
  SEQ *S = P->S;
  static int flag;
  
  if ( k>= 0 ){
    P->cur_chunk = k;
    P->chunk_head = S->plen_org*P->cur_chunk/P->chunk;
    P->chunk_tail = S->plen_org*(P->cur_chunk+1)/P->chunk;
    S->plen = P->chunk_tail - P->chunk_head;
    FLOOP (t, 0, P->pos_list_num) P->pos_list[t] += P->chunk_head;  // shift the pos's
    flag = 0;
    if ( S->plen*P->chunk < S->plen_org ){ // 1-letter short pattern
      P->pos_dep[P->dep_max*2-1]--;
      P->ppartition.v[P->pblock_num*2-1]--;
      if ( P->pos_dep[P->dep_max*2-1] == P->pos_dep[P->dep_max*2-2] ){ P->dep_max--; flag |= 1;}
      if ( P->ppartition.v[P->pblock_num*2-1] == P->ppartition.v[P->pblock_num*2-2] ){ P->pblock_num--; flag |= 2; }
    }
  } else {
    FLOOP (t, 0, P->pos_list_num) P->pos_list[t] -= P->chunk_head;  // shift the pos's
    if ( S->plen*P->chunk < S->plen_org ){ // 1-letter short pattern
      if ( flag&1 ) P->dep_max++;
      P->pos_dep[P->dep_max*2-1] ++;
      if ( flag&2 ) P->pblock_num++;
      P->ppartition.v[P->pblock_num*2-1]++;
    }
  }
}


/* classify pattern strings beginning at positions in pos_list */
/* for positions having the same pattern strings, set their sc to a value defined */
#ifndef POS_CLASSIFY_VAL
#define POS_CLASSIFY_VAL 0
#endif
void POS_classify (POS *P, SEQ_LONG *pos, SEQ_LONG t, int dep){
  QUEUE_INT *x;
  SEQ_LONG s=0;
  SEQ *S = P->S;
  if ( t<=1 ) return;
  if ( dep == P->dep_max ){
    if ( P->sc ){
      P->sc[pos[0]] = P->sc_mark;
      FLOOP (s, 1, t) P->sc[pos[s]] = P->sc_mark2; // set sc of duplicated pattern string to 0
    }
    return;
  }
  SEQ_bucket_sort (S, pos, t, P->pos_dep[dep*2], P->pos_dep[dep*2+1], &P->jump[dep], P->let_cnt[dep], P->let_cnt[dep+1]);
  MQUE_FLOOP (P->jump[dep], x){
    POS_classify (P, &(pos[s]), P->let_cnt[dep][*x]-s, dep+1);
    s = P->let_cnt[dep][*x];
    P->let_cnt[dep][*x] = 0;
  }
}

/* remove duplicated pattern strings (those sc[]=0) from position list */
void POS_reduce_dup (POS *P, int k){
  SEQ_LONG i, ii=0, p;
  if ( !P->sc ) return;
  FLOOP (i, 0, P->pos_list_num){
    p = P->pos_list[i];
    if ( P->sc[p] != k ){
      P->pos_list[ii] = P->pos_list[i];
      ii++;
    }
  }
  P->pos_list_num = ii;
}

/* temporary memory string ID's, length to head/tail etc., for pairwise comparison */
//void SACHICA_set_cache (SACHICA *SA, SEQ_LONG *pos, SEQ_LONG t, int core){
void SACHICA_set_cache (SACHICA *SA, SACHICA_MUL *M, SEQ_LONG *pos, SEQ_LONG t){
  SEQ_LONG i, j, p;
  SEQ *SS = &SA->PP.SS;
  SEQ_ID s, *ID;
//  unsigned short *head, *tail;
  SEQ_LONG *head, *tail;
  char *fa, *fb;

  if ( M->IDend <= (int)t ){
    M->IDend = MAX ((int)t+10, M->IDend*2);
    SPIN_LOCK (SA->PP.II.multi_core, SA->PP.II.lock_counter);  // lock!!
    realloc2 (M->flag_a, M->IDend, EXIT);
    realloc2 (M->flag_b, M->IDend, EXIT);
    realloc2 (M->ID, M->IDend, EXIT);
    realloc2 (M->tohead, M->IDend, EXIT);
    realloc2 (M->totail, M->IDend, EXIT);
    SPIN_UNLOCK (SA->PP.II.multi_core, SA->PP.II.lock_counter);  // lock!!
  }
  ID = M->ID;
  head = M->tohead; tail = M->totail;
  fa = M->flag_a; fb = M->flag_b;
  FLOOP (i, 0, t){
    p = pos[i];
    *ID = s = SEQ_get_substID (SS, p);
    j = p - SS->head[s];
    if ( (SS->flag&SEQ_SEGMENT) && p<SS->matrix_pos ){
      j = *head = j % SS->clms[s];
      *tail = SS->clms[s] - *head;
    } else {
      *head = MIN (65535, j);
      *tail = MIN (65535, SS->tail[s] -p);
    }
    *fa = j %SS->pos_skip_a;
    *fb = ((j/SS->pos_skip_a)%SS->pos_skip_b) *SS->pos_skip_a;
    ID++; head++; tail++; fa++; fb++;
  }
}

/* pairwise compare of all pattern strings in position list  */
void SACHICA_pairwise_comparison (SACHICA *SA, POS *PS, SACHICA_MUL *M, SEQ_LONG *pos, SEQ_LONG t, int block, int block_end){
  SEQ *SS = &SA->PP.SS;
  int k, f, core_id = M->core_id;
  char flag_a=0, flag_b=0, flag_aa, flag_bb;
  SEQ_ID sx=0, sy=0;
  SEQ_LONG i, j, pi, pj, ppi, l, jt=t, r=0, sss, end_l, end_r, tt, tt1=t, tt2=t;
//  SEQ_LONG ii, jj, it, jt, ss;
//printf ("%d %d %d %d %d\n", pos-PS->pos_list, t, block, block_end, core_id); QUEUE_print__ (remain_block);

    // group output
  if ( SA->PP.problem & SACHICA_GROUP ){
    if ( t < SS->plen_lb || t > SS->plen_ub ) return;
//    SPIN_LOCK(SA->PP.II.multi_core, SA->PP.II.lock_output);
//    printf ("%d,%d   %d\n", pos - SA->PP.PS.pos_list, t, block);
//    SPIN_UNLOCK(SA->PP.II.multi_core, SA->PP.II.lock_output);

    FLOOP (i, 0, t){
      SEQ_fprint_position (&SA->PP.II.multi_fp[core_id], SS, pos[i], flag_a);
      if (SA->PP.II.multi_fp[core_id].buf > SA->PP.II.multi_fp[core_id].buf_org + FILE2_BUFSIZ/2){
        sx = 1;
        SPIN_LOCK(SA->PP.II.multi_core, SA->PP.II.lock_output);
        FILE2_flush_ (&SA->PP.II.multi_fp[core_id]);
      }
      flag_a = SS->separator;
    }
    FILE2_putc (&SA->PP.II.multi_fp[core_id], '\n');
    if ( sx ){
      FILE2_flush_ (&SA->PP.II.multi_fp[core_id]);
      SPIN_UNLOCK(SA->PP.II.multi_core, SA->PP.II.lock_output);
    }
    return;
  }

  if ( SS->separated_pos > 0 ){
    tt = SEQ_partition_by_substID (SS, pos, t);
    if ( SA->pw_flag4 ){
      tt1 = POS_partition_by (PS, pos, tt);
      tt2 = POS_partition_by (PS, pos+tt, t-tt);
    }
  } else if ( SA->pw_flag4 ) tt = POS_partition_by (PS, pos, t);
  else tt = t-1;
  if ( SA->pw_flag3 ) SACHICA_set_cache (SA, M, pos, t);

//  for (ii=0 ; ii<tt ; ii+=80){ it = (ii+80<tt)? ii+80: tt;  // first loop
//  ss = SS->separated_pos>0? tt: ii+1;
//  for (jj=ss ; jj<t ; jj+=80){ jt = jj+80<t? jj+80: t;  // first loop
//  FLOOP (i, ii, it){  // first loop
  FLOOP (i, 0, tt){  // first loop
    pi = pos[i];
//    if ( jj==ss ){
//      sss = SS->separated_pos>0? tt: i+1; SA->PP.II.multi_iters2[core_id] += t - sss;
//    } else sss = jj;
    sss = SS->separated_pos>0? tt: i+1; SA->PP.II.multi_iters2[core_id] += t - sss;
//    if ( i==tt1 && SS->separated_pos>0 && SA->pw_flag4 ) jt = tt2;
    if ( i>=tt1 && SS->separated_pos>0 && SA->pw_flag4 ){ tt = tt2; jt = tt2; }
    if ( t > SA->trancate ){ ENMIN (jt, sss+128);}
    if ( SA->pw_flag3 ){
      sx = M->ID[i];
      flag_a = M->flag_a[i];
      flag_b = M->flag_b[i];
    }
    FLOOP (j, sss, jt){ // second loop
      pj = pos[j];
        // get chached value
      if ( SA->pw_flag3 ){
        sy = M->ID[j];
        flag_aa = M->flag_a[j];
        flag_bb = M->flag_b[j];
        if ( SS->flag&SEQ_MULTI_STRING && sx==sy ) continue;
        if ( SS->interleave_len > 1 ){
          if ( (flag_a && flag_aa) || (flag_b && flag_bb) ) continue;
          if ( SS->separated_pos==0 && ((pi<pj&&(flag_a || (!flag_b && flag_bb))) || (pi>pj && (flag_aa || (flag_b && !flag_bb)))) ) continue;
        }
      }
      if ( SS->micro_chr_num>0 ) k = POS_remain_mismatch_ (PS, pi, pj, block, block_end);
      else k = POS_remain_mismatch (PS, pi, pj, block, block_end);
      if ( k <= SS->perr_org || ((PS->flag & POS_ONE_CHUNK_MATCH) && k<SS->plen_org) ){  // similar pair is found
        ppi = pi - PS->chunk_head; pj -= PS->chunk_head;  // un-shift the positions
        SA->PP.II.multi_outputs2[core_id]++; // increasing counter
        if ( SA->pw_flag2 ){
          end_l = MIN (M->tohead[i], M->tohead[j]) -PS->chunk_head;
          end_r = MIN (M->totail[i], M->totail[j]) +PS->chunk_head;
          f = SEQ_maximalize_pair (SS, ppi, pj, end_l, end_r, SS->err_max, SS->err_ratio, &k, &l, &r, SS->flag);
          if ( f<0 ) continue;
//          if ( SA->PP.problem & SACHICA_LENGTH_HEAD ){
          if ( SA->PP.th > 0 ){
            f = (SS->plen_org+l+r) >= SA->PP.th * (SS->tail[sx] - SS->head[sx])? 1: 0;
            if ( (SS->plen_org+l+r) >= SA->PP.th * (SS->tail[sy] - SS->head[sy]) ) f |= 2;
            if ( (f<3 && !(SA->PP.problem & SACHICA_ONE_SIMILAR)) || f==0 ) continue;
          } 
          if ( SA->PP.problem & SACHICA_OVERLAP ){
            if ( f<3 ) continue;
            if ( SS->err_ratio > 0 && k > SS->err_ratio * (end_l+end_r) ) continue;
            if ( SS->err_max > 0 && k > SS->err_max ) continue;
          } else if ( (SA->PP.problem & SACHICA_OVERLAP1) && f<1 ) continue;
          if ( !RANGE(SS->plen_lb, l+r+SS->plen_org, SS->plen_ub) ) continue;
#ifdef SACHICA_POSTPROCESS
          SACHICA_postprocess (SA, sx, ppi-l, sy, pj-l, ((SA->PP.problem&(SACHICA_OVERLAP+SACHICA_OVERLAP1))?k:l+r+SS->plen_org), core_id);
#else
       POS_fprint_pair (&SA->PP.II.multi_fp[core_id], PS, ppi-l, pj-l, ((SA->PP.problem&(SACHICA_OVERLAP+SACHICA_OVERLAP1))?k:SS->plen_org + l+r -((SA->PP.problem&SACHICA_LENGTH_HEAD)? SS->plen-1: 0)), core_id);
#endif
          continue;
        }
/*
        if ( SS->extend>0 ){
          l = SEQ_extend_pair (SS, ppi, pj, SS->extend, SS->err_max, SS->err_ratio, &k);
          if ( l < (SEQ_LONG)SS->extend ) continue;
          ppi -= l; pj -= l;
        }
*/
#ifdef SACHICA_POSTPROCESS
        SACHICA_postprocess (SA, SEQ_get_substID(SS,ppi), ppi, SEQ_get_substID(SS,pj), pj, k, core_id);
#else
        POS_fprint_pair (&SA->PP.II.multi_fp[core_id], PS, ppi, pj, k, core_id);
#endif
      }
    }
  }
//  }
//  }
}

/* insert block to pos_dep and ppartition, that are used in further classification */
void SACHICA_iter2_ins_block (POS *PS, int x, int *block_end, int *num){
  int mid;
  QUEUE *P = &PS->ppartition;
  if ( (*num)==0 ){
    QUE_INS (*P, P->v[x*2]);
    QUE_INS (*P, P->v[x*2+1]);
    (*block_end)++;
    return;
  }
  mid = (P->v[x *2] + P->v[x *2+1]) /2;
  if ( mid > P->v[x *2] ){
    QUE_INS (*P, P->v[x *2]);
    QUE_INS (*P, mid);
    (*block_end)++;
  }
  QUE_INS (*P, mid);
  QUE_INS (*P, P->v[x *2+1]);
  (*block_end)++;
  (*num)--;
}

/* further classification */
void SACHICA_iter2 (SACHICA *SA, POS *PS, SACHICA_MUL *M, SEQ_LONG *pos, SEQ_LONG t, int block, int dep, int level, int num){
  QUEUE R = PS->remain_block;
  int i, t2=0, pt = PS->ppartition.t;
  int m = PS->dep_max, block_end = PS->pblock_num;

     // flag for both can not be "not in remain_block", and "has to remain mark[i]-1 mismatches"
//  FLOOP (i, 0, SS->perr - (block_end-block)){
  FLOOP (i, 0, PS->remain_block.t){
    if ( (PS->remain_block.t-i) > num ){
      PS->remain_block.v[PS->remain_block.t +(t2++)] = PS->remain_block.v[i];
    } else {
      PS->ppartition_mark[PS->pblock_num+ (i-t2)*2] = 1;
      PS->ppartition_mark[PS->pblock_num+ (i-t2)*2+1] = i +2 + (block_end - block);
    }
//    PS->ppartition_mark[PS->pblock_num+ i*2] = 1;
//    PS->ppartition_mark[PS->pblock_num+ i*2+1] = i +2 + (block_end - block);
  }
  FLOOP (i, 0, PS->remain_block.t){
    if ( PS->remain_block.t - i <= num )
        SACHICA_iter2_ins_block (PS, PS->remain_block.v[i], &block_end, &num);
//  MQUE_FLOOP (*remain_block, x){
//    SACHICA_iter2_ins_block (SS, *x, &block_end, &num);
  }
  for ( ; block<PS->pblock_num ; block++)
      SACHICA_iter2_ins_block (PS, block, &block_end, &num);
  
  POS_mk_pos_dep (PS, pt);
  PS->remain_block.v += PS->remain_block.t;
  PS->remain_block.t = t2;
  SACHICA_iter (SA, PS, M, pos, t, PS->pblock_num, t2, m, level, block_end, 1);

  ARY_FILL (PS->ppartition_mark, PS->pblock_num, PS->ppartition.t+1, 0);
  PS->remain_block = R;
  PS->ppartition.t = pt;
  PS->dep_max = m;
}

/* iteration of multi-classification algorithm */
/* flag==0: normal bucket sort, flag==1, use id, flag==2   */
void SACHICA_iter (SACHICA *SA, POS *PS, SACHICA_MUL *M, SEQ_LONG *pos, SEQ_LONG t, int block, int mis, int dep, int level, int block_end, int branch_flag){
  SEQ *SS = &SA->PP.SS;
  ITEMSET *II = &SA->PP.II;
  int i, k, first = (level==0 && !branch_flag), f;
  QUEUE_INT *x;
  int multi_lock=0, multi_prog=0;  // for exclusive opearation in multicore mode
  SEQ_LONG s=0, u= t*(SS->perr+1)*PS->chunk/100, pr=II->progress, aa=0, tt, ttt;
  SACHICA_MULTI_CORE *SM; POS *PS2;

#ifdef MULTI_CORE
  void *tr;
#endif
  II->multi_iters[M->core_id] += t;


  if ( t<=1 ) return;
  if ( branch_flag ){
    if (SS->separated_pos > 0){ tt = SEQ_count_by_substID (SS, pos, t); ttt = MIN(tt, t-tt); }
    else if ( SA->pw_flag4 ) ttt = POS_count_by (PS, pos, t);
    else ttt = t;
    if ( ttt == 0 ) return;
//    if ( SA->PP.problem & SACHICA_GROUP ) ttt = 100;
    k = PS->remain_block.t;
    if ( block+(SS->perr-mis) == block_end ){ // bottom of recursion -> pairwise comparison
      tt = t/SA->iter2_factor;
      f=1; FLOOP (i, 0, PS->remain_block.t){
        x = &PS->ppartition.v[PS->remain_block.v[i]*2];
        if ( *(x+1) - *x == 1) f=0;
      }
//      if ( f && SS->perr >0 && PS->ppartition.t/2<=PS->pblock_num && tt>10 && ttt>3 ){
      if ( 0 && f && SS->perr >0 && PS->ppartition.t/2<=PS->pblock_num && tt>10 && ttt>3 ){
        SACHICA_iter2 (SA, PS, M, pos, t, block, dep, level, tt>5000?3:(tt>200?2:1));
        goto END1;
      }
    } else {
      // examine all cases for inserting un-compared blocks
      s = MAX(PS->ppartition.t/2-block, 1);
      FLOOP (i, 1, SS->perr-mis+1) s = s * (PS->ppartition.t/2-block-i+1)/i;
      if ( (SA->PP.problem & SACHICA_GROUP)|| (t >= s*5+10 && ttt>3) || (PS->ppartition_mark[block]>0 && (mis >PS->ppartition_mark[block]-2 || PS->ppartition_mark[block+1]>0))){
//      if ( t >= s*5+5 || PS->ppartition_mark[block]>0 ){
        while (1){
          if ( PS->ppartition_mark[block] <= 1 || PS->remain_block.v[PS->remain_block.t-1]==block-1 ){ // forbid that both are not in remain-block
            SACHICA_iter (SA, PS, M, pos, t, block, mis, dep, level, block_end, 0);
          }
          if ( PS->ppartition_mark[block]>=2 && mis >PS->ppartition_mark[block]-2 ) break; // forbid that both are in remain-block
          if ( ++mis > SS->perr ) break;
          QUE_INS (PS->remain_block, block);
          block++;  // next block to be bucket-sorted
          while ( PS->pos_dep[dep*2] != PS->ppartition.v[block*2] ) dep++;
        }
        goto END1;
      }
    }
    while ( PS->ppartition_mark[block]>0 ){ QUE_INS (PS->remain_block, block); block++; }

    SACHICA_pairwise_comparison (SA, PS, M, pos, t, block, block_end);
    END1:;
    PS->remain_block.t = k;  // reset queue for storing un-compared blocks
    return;
  } else {
    if ( (II->flag&SHOW_PROGRESS) && first ) print_err ("phase %d (remaining positions " SEQ_LONGF "\n", block, t);
    II->multi_iters3[M->core_id] += t;
    SEQ_bucket_sort (SS, pos, t, PS->pos_dep[dep*2], PS->pos_dep[dep*2+1], &PS->jump[level], PS->let_cnt[level], PS->let_cnt[level+1]);
    branch_flag = (PS->pos_dep[dep*2+1] == PS->ppartition.v[block*2+1]);
    if ( branch_flag ) block++;
    if ( II->multi_core > 0 && first ){
      malloc2 (SM, II->multi_core, EXIT);
      malloc2 (PS2, II->multi_core, EXIT);
      BLOOP (k, II->multi_core, 0){
        SM[k].SA = SA;
        SM[k].PS = k>0? &PS2[k]: PS;
        SM[k].pos = pos;
        SM[k].t = t;
        SM[k].block = block;
        SM[k].mis = mis;
        SM[k].dep = dep;
        SM[k].level = level;
        SM[k].block_end = block_end;
        SM[k].branch_flag = branch_flag;
        SM[k].pr = pr;
        SM[k].core_id = k;
        SM[k].lock_i = &multi_lock;
        SM[k].lock_s = &s;
        SM[k].lock_prog = &multi_prog;

        if (1|| k>0 ) POS_multicore_dup (&PS2[k], PS, level+1);
#ifdef MULTI_CORE
        if ( k > 0 ) pthread_create (&(SM[k].thr), NULL, SACHICA_iter_multi, (void*)(&SM[k]));
        else 
#endif
          SACHICA_iter_multi ((void*)(&SM[k]));
      }
      // wait until all-created-threads terminate
#ifdef MULTI_CORE
      FLOOP (k, 1, II->multi_core){
        pthread_join (SM[k].thr, &tr);
        POS_multicore_end (&PS2[k], level+1);
      }
#endif
      free2 (SM);
      free2 (PS2);
      return;
    }
    MQUE_FLOOP (PS->jump[level], x){
//      printf ("%d %d %d %d  %d:%d\n", level, *x, PS->let_cnt[level][*x], s, x-PS->jump[level].v, PS->jump[level].t);
      SACHICA_iter (SA, PS, M, &(pos[s]), PS->let_cnt[level][*x]-s, block, mis, dep+1, level+1, block_end, branch_flag);
      // show progress of computation
      if ( u && (II->flag&SHOW_PROGRESS) && first ){
        aa += PS->let_cnt[level][*x] - s;
        if ( aa > (II->progress-pr+1)*u ){
          II->progress = pr + aa/u;
          print_err ("%d/100\n", II->progress);
        }
      }
      s = PS->let_cnt[level][*x];
      PS->let_cnt[level][*x] = 0;
    }
  }
}

void *SACHICA_iter_multi (void *p){
  SACHICA_MULTI_CORE *SM = (SACHICA_MULTI_CORE *)p;
  POS *PS = SM->PS;
  PROBLEM *PP = &SM->SA->PP;
  ITEMSET *II = &PP->II;
  int i, i_end, e;
  int level=SM->level, *lock_i = SM->lock_i, *lock_prog=SM->lock_prog;
  QUEUE *jump = &PP->PS.jump[level];
  SEQ_LONG u= SM->t*(PP->SS.perr+1)*PP->PS.chunk/100, ss;

  while (1){
    SPIN_LOCK (II->multi_core, II->lock_counter);  // lock!!

    if ( *lock_i >= jump->t ){
      SPIN_UNLOCK (II->multi_core, II->lock_counter);  // unlock!!
      break;
    }
    ss = *(SM->lock_s);
    i = *lock_i;
    (*lock_i)++;
    while ( *lock_i<jump->t && PP->PS.let_cnt[level][jump->v[*lock_i]]-ss<1000) (*lock_i)++;
    i_end = *lock_i;
    *(SM->lock_s) = PP->PS.let_cnt[level][jump->v[*lock_i-1]];
    if ( PP->II.flag & SHOW_PROGRESS ){
      *lock_prog += *(SM->lock_s)-ss;
      if ( u && *lock_prog > (int)((II->progress-SM->pr+1)*u) ){
        II->progress = SM->pr + *lock_prog/u;
        print_err ("%d/100\n", II->progress);
      }
    }
    SPIN_UNLOCK (II->multi_core, II->lock_counter);  // unlock!!
    
    for ( ; i<i_end ; i++){
      e = jump->v[i];
      SACHICA_iter (SM->SA, PS, &SM->SA->MUL[SM->core_id], &(SM->pos[ss]), PP->PS.let_cnt[level][e] -ss, SM->block, SM->mis, SM->dep+1, level+1, SM->block_end, SM->branch_flag);
        // show progress of computation
      ss = PP->PS.let_cnt[level][e];
      PP->PS.let_cnt[level][e] = 0;
    }
  }
  return (NULL);
}

/* reverse strings in even lines (matrix mode) */
void SEQ_reverse_even (SEQ *S){
  SEQ_LONG j;
  SEQ_ID i;
  FLOOP (i, 1, (SEQ_ID)S->matrix_by){
    for (j=S->head[i] ; j<S->tail[i] ; j+=S->clms[i]*2){
      SEQ_opposite_genome (S, j, j+S->clms[i]);
      SEQ_reverse_string (S->s, j, j+S->clms[i]);
    }
  }
}

/* make position list and remove unnecessary positions */
void SACHICA_mk_pos_list (SACHICA *SA){
  SEQ *SS = &SA->PP.SS;
  POS *PS = &SA->PP.PS;
  SEQ_LONG i;
  
  POS_mk_pos_list (PS);
  if ( SS->interleave_len_org > 1 )
      print_mes (SS, "interleave %d : %d\n", SS->pos_skip_a, SS->pos_skip_b);
  if ( PS->skip_chr_ub < SS->plen_org ) POS_rm_pos_with_ignore_chr (PS);
  if ( PS->skip_repeat_th < SS->plen_org ) POS_rm_pos_repeated_string (PS, PS->skip_repeat_th);

  print_mes (SS, "#positions=" SEQ_LONGF, PS->pos_list_num);
  if ((SA->PP.problem&SACHICA_MISMATCH) && !(SS->flag&SEQ_MULTI_STRING) && !(PS->flag&POS_STR_SC)){
    POS_classify (PS, PS->pos_list, PS->pos_list_num, 0);
    POS_reduce_dup (PS, PS->sc_mark2);
    FLOOP (i, 0, PS->pos_list_num) if ( PS->sc[i] == PS->sc_mark2 ) PS->sc[i] = PS->sc_mark;
    print_mes (SS, ", reduced #positions=" SEQ_LONGF, PS->pos_list_num);
  }
  print_mes (SS, "\n");
}

/* initialization for main routine */
void SACHICA_init (SACHICA *SA){
  PROBLEM *PP = &SA->PP;
  SEQ *SS = &PP->SS;
  POS *PS = &PP->PS;
  int i;

#if defined(WIN32) && defined(MULTI_CORE) && defined(PTW32_STATIC_LIB)
  ptw32_processInitialize();
#endif

    // disable buffering of stderr/stdout
//  setvbuf (stdout, NULL, _IONBF, 0);
  setvbuf (stderr, NULL, _IONBF, 0);

  if ( PS->sc_th == POS_SC_END+1 ) PS->sc_th = POS_SC_END-2;
  SS->flag |= SEQ_MULTI_OUTPUT;
  PS->flag |= POS_REMAIN_BLOCK;
  POS_alloc (PS, SS, &PP->II);
  PROBLEM_alloc (PP, 0, 0, 0, 0, 0);
  POS_hash_siz (PS);

  if ( PP->problem & SACHICA_NO_MULTI ) BITRM (SS->flag, SEQ_MULTI_STRING);
/*
  if ( (PP->problem & SACHICA_MISMATCH) && (PP->PS.flag & (POS_SC_MIN+POS_STR_SC_MIN)) && SS->reduced_by == 0 ){
    SS->reduced_by = SS->str_num; SS->reduced_pos = SS->str_len;
  }
*/

    // print input information
  if ( !(PP->problem & SACHICA_PRINT) && (SS->flag&SHOW_MESSAGE) ){
    print_err ("#blocks= %d ,#subblocks= %d ,#chunks= %d\n",PS->pblock_num,PS->dep_max,PS->chunk);
    if ( PP->position_fname ) print_err ("position_file= %s\n", PP->position_fname);
    if ( PP->header_fname ) print_err ("header_file= %s\n", PP->header_fname);
  }
  internal_params.i1 = SS->chr_num;
  internal_params.i2 = SS->max_str;
  internal_params.i3 = PS->pblock_num;
  internal_params.i4 = PS->dep_max;
  internal_params.i5 = PS->chunk;
  internal_params.i6 = SS->separated_by;
  internal_params.i7 = SS->reversed_by;

  if ( PP->problem&SACHICA_EXT_VALID ) SEQ_extract_valid_string (SS, PS->skip_chr, PS->skip_chr_ub);  // extracting valid strings

  print_mes (SS, "file read finished\n");
    // write to header file
  if ( PP->header_fname ) SEQ_fprint_headtail (SS, PP->header_fname);  // write header file
  if ( SS->plen_org<=0 ) return;

  if ( PP->problem & SACHICA_DOUBLE_READ ) SEQ_reverse_even (SS);

//SEQ_fprint_all_string (stdout, SS);

// read sc file
  if ( PP->sc_fname ){
    if ( PP->problem & SACHICA_PRINT )
        SEQ_fprint_pos_substrings (SS, PP->sc_fname, PP->output_fname);
    else if ( PS->flag & POS_STR_SC ) POS_read_str_sc (PS, PP->sc_fname);
    else POS_read_sc (PS, PP->sc_fname);
  } else if ( PP->problem & SACHICA_PRINT ){
    if ( SS->flag & SEQ_OUTPUT_STRING ){
      if ( SS->plen_org<1 || SS->plen_org>=(int)SS->str_num ) print_err (" %d-th string does not exist\n", SS->plen_org);
      else SEQ_fprint_string (stdout, SS, &SS->s[SS->head[SS->plen_org]], SS->tail[SS->plen_org]-SS->head[SS->plen_org], 0);   // write [num]th substring
    } else SEQ_fprint_string (stdout, SS, &SS->s[SS->plen_org], SS->perr_org, 0);   // write specified substring
  }
//  SA->flag_a = SA->flag_b = NULL;
//  SA->totail = SA->tohead = NULL;
//  SA->IDbuf = NULL;
//  SA->IDbuf_end = 0;
  ARY_FILL (PS->ppartition_mark, 0, PS->ppartition.t*2+1, 0);
  
  SA->pw_flag1 = ((SS->separated_pos==0) && ((SS->flag&SEQ_MULTI_STRING) || SS->interleave_len_org>1));
  SA->pw_flag2 = (SS->flag & SEQ_MAXIMAL) || (PP->problem&(SACHICA_OVERLAP+SACHICA_OVERLAP1)) || SA->PP.th >0;
  SA->pw_flag3 = SA->pw_flag1 || SA->pw_flag2;
  SA->pw_flag4 = SS->output_pos>0  || (PS->flag & (POS_SC_COUNT+POS_STR_SC_COUNT));
  if ( PS->flag & POS_STR_SC_COUNT ) PS->partition_th = PS->str_sc_max-1;
  if ( PS->flag & POS_SC_COUNT ) PS->partition_th = PS->sc_max-1;

    // allocation for multi processors
  malloc2 (SA->MUL, MAX(PP->II.multi_core,1), EXIT);
  FLOOP (i, 0, MAX(PP->II.multi_core,1)){
    SA->MUL[i].core_id = i;
    SA->MUL[i].IDend = 0;
    SA->MUL[i].ID = NULL;
    SA->MUL[i].tohead = SA->MUL[i].totail = NULL;
    SA->MUL[i].flag_a = SA->MUL[i].flag_b = NULL;
  }
  if ( SA->trancate == 0 ) SA->trancate = SS->str_len;
}


/***************************************/
/* termination of sachica main routine */
/***************************************/
void SACHICA_end (SACHICA *SA){
  int i;
#ifdef SACHICA_POSTPROCESS
  SACHICA_postprocess_end (SA);
#endif
  PROBLEM_end (&SA->PP);
  if ( SA->PP.problem & SACHICA_MASK_STRING ){ free2 (SA->headmax); free2 (SA->tailmax); }
//  mfree (SA->flag_a, SA->flag_b, SA->IDbuf, SA->tohead, SA->totail);
  FLOOP (i, 0, MAX(SA->PP.II.multi_core,1))
      mfree (SA->MUL[i].ID, SA->MUL[i].tohead, SA->MUL[i].totail, SA->MUL[i].flag_a, SA->MUL[i].flag_b);
  free2 (SA->MUL);
}

/*************************************/
/* main routine of sachica algorithm */
/*************************************/
//int SACHICA_main (int argc, char *argv[]){
int SACHICA_main2 (SACHICA *SA){
//  SACHICA SA;
  SEQ *SS = &SA->PP.SS;
  POS *PS = &SA->PP.PS;
  ITEMSET *II = &SA->PP.II;
  int dif, i;
  clock_t tt=clock();

  if ( (SA->PP.problem & SACHICA_PRINT) || SS->plen==0 ) goto END;

  dif = SS->err_max - SS->perr_org;
  SS->perr_org = SS->perr_org2/PS->chunk;
  SACHICA_mk_pos_list (SA);
#ifdef SACHICA_POSTPROCESS
  SACHICA_postprocess_init (SA);
#endif

if ( ERROR_MES ) goto END;
//  for (SS->perr=SS->perr_min/PS->chunk ; SS->perr<=SS->perr_org ; SS->perr++ ){
  if ( SS->reduced_pos > 0 && SA->PP.sc_fname ) POS_reduce_pos (PS);   // first reduction
  
  for (SS->perr_org=SS->perr_min ; SS->perr_org<SS->perr_org2+1 ; SS->perr_org +=SS->perr_inc){
if ( SS->perr_min < SS->perr_org2 ) print_mes (SS, "#mismatch= %d\n", SS->perr_org);
    SS->perr = SS->perr_org/PS->chunk;    // set relative #err
    SA->iter2_factor = 1; FLOOP (i, 0, SS->perr) SA->iter2_factor *= 2;
    if ( (PS->flag & (POS_SC_MIN + POS_STR_SC_MIN)) && SS->perr_min<SS->perr_org2 )
         PS->partition_th = SS->perr_org;

    FLOOP (PS->cur_chunk, 0, PS->chunk){
      POS_shift_pos (PS, PS->cur_chunk);
      SS->err_max = SS->perr_org+dif;
      SACHICA_iter (SA, &SA->PP.PS, &SA->MUL[0], PS->pos_list, PS->pos_list_num, 0, 0, 0, 0, PS->pblock_num, 1);
      POS_shift_pos (PS, -1);
      if ( SS->perr_min < SS->perr_org2 ){
        if ( PS->flag & POS_SC_USE ) POS_compute_sc_static (PS, SS->perr);
        if ( SS->reduced_pos > 0 ) POS_reduce_pos (PS);
      }
    }
  }

  ITEMSET_merge_counters (II);
  internal_params.l1 = II->outputs2;
  internal_params.l2 = II->outputs;
  if ( SS->flag & SHOW_MESSAGE ){
    print_mes (SS, "#iters " LONGF " ,#comparisons " LONGF ",#sorts " LONGF "\n", II->iters, II->iters2, II->iters3);
    print_mes (SS, "#similar_pairs " LONGF " ,#output_pairs " LONGF "\n", II->outputs2, II->outputs);
    if ( SS->perr_min < SS->perr_org2 && PS->sc )
        POS_fprint_sc_static (PS, PS->flag & POS_STR_SC);
  }
  SA->PP.problem |= SACHICA_PHASE;

// output routine

  if ( SA->PP.problem & SACHICA_MASK_STRING ) SACHICA_output_masked_string (SA);
  else if ( !(SS->flag & SEQ_OUTPUT_PAIR) && II->fp ) POS_fprint_pos_sc (II->fp, PS);

  END:;
  if ( print_time_flag )
      print_mes (SS, "computation_time= %3f\n", ((double)(clock() - tt))/CLOCKS_PER_SEC);
  return (ERROR_MES?1:0);
}

int SACHICA_main (int argc, char *argv[]){
  SACHICA SA;
  int r;
  PROBLEM_init (&SA.PP);
  SACHICA_read_param (argc, argv, &SA);
  SACHICA_set_param (&SA);
  if ( !ERROR_MES ){
    PROBLEM_load (&SA.PP);
    SACHICA_init (&SA);
    r = SACHICA_main2 (&SA);
  } else return (1);
  SACHICA_end (&SA);
  return (r);
}


/*******************************************************************************/
#ifndef _NO_MAIN_
#define _NO_MAIN_
int main (int argc, char *argv[]){
  return (SACHICA_main (argc, argv) );
}
#endif
/*******************************************************************************/

#endif


